︠742275ca-04e5-4e7c-b4ef-7f05b3053ec0︠
# Mini project: Comparing convergence of the simple iteration method and the Newton's method
#Consider the function f(x)=exp(-x)*(x^2-5*x-2)+1.
# Plot the function to convince yourself that the function has two roots. For each of the roots use the "find_root" function to obtain high accuracy value of the root1 and root2.
#For each of the roots Do the following
#(a) (challenging!) Convert the root-finding problem for f to a fixed point problem g(x)=x with appropriate function g.
#(b) Choose an initial approximation of the root that guarantees convergence of the simple iteration and make a list L with n=7 iterates using simple iteration.
#(c) Use the same initial guess for solving the root-finding problem by Newton's method. Make a list N with n=7 iterates using Newton's iterations.
#(d) Make a table with 7 rows for x[n]-values, n=0..6, and 3 columns with the table header n, L[n],and N[n]. Compare convergence of these two methods.
︡1eadac08-9ca7-4dde-af48-ef961b0fa360︡
︠86355c0e-0602-48b5-9464-efb4ba0c479a︠
f(x)=exp(-x)*(x^2-5*x-2)+1
plot(?)
︡b7b3ae17-f6d9-480e-875b-d4d6b83fe698︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/318/tmp_KuZ43f.svg","show":true,"text":null,"uuid":"9b975654-1811-4dbe-b8c2-7223a422531a"},"once":false}︡{"done":true}
︠4a4d22cb-68d7-423c-8776-201a8f6a64c0︠
root1=find_root(f,?);root1
︡626ddd22-99ce-4b6d-87c5-785c1f3f7586︡{"stdout":"-0.23054999321338895\n"}︡{"done":true}
︠1be9301c-84f6-42e7-960e-608667dcd58f︠
root2=find_root(f,?);root2
︡7ea6cba3-43db-464e-8671-a97f2c5d9fae︡{"stdout":"2.0895848494844653\n"}︡{"done":true}
︠94307de5-07dc-43ca-ba01-bb055db3ccae︠
#Version 1
# (a) Solve the equation f(x)=0 for x. Hint: there are three options here. Do not solve for x in the exponential function. The other two options will work.
g1(x)=?
︡f041315d-0631-48df-9fcd-6dedadb96c56︡{"done":true}
︠0d70e8bf-3792-4c7d-a23a-6cbc8831ec58︠
line_plot1=plot(x,-1,0)
g1plot=plot(g1,-1,3,figsize=[4,3])
g1prime_plot=plot(?,color='red')
(g1plot+g1prime_plot+line_plot1).show()
︡79140986-0f12-433a-ae87-e0e2428c098b︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/318/tmp_QLwri6.svg","show":true,"text":null,"uuid":"c3b5f704-f505-42bf-95bd-06d876899b8c"},"once":false}︡{"done":true}
︠52e0da3e-c342-48fa-a928-8f47cbbed09d︠
#(b) g1 works well for root1; gprime near the root1 is ?. Let x0=-0.9
def simple_iteration(g,a,n):
    L=[a]
    temp=a
    for j in range(1,n+1):
        temp=g(?).n()# Encode the iteration formula here
        L.append(temp)
    return L

simple_it_list1=simple_iteration(?,?,?);simple_it_list1
︡3fe6cf19-3a90-452e-a895-3572436c62dc︡{"stdout":"[-0.900000000000000, -0.156686068051880, -0.224095411245832, -0.230108474460778, -0.230520533881549, -0.230548030998561, -0.230549862530082, -0.230549984509961]\n"}︡{"done":true}
︠e00e5690-d093-4b91-a166-541a011df254︠
# (c) Plot of f shows that the same initial guess will work for approximating root1 by Newton's method ( since ?>0)
def my_newton(f,a,n):
    L=[a]
    fprime=diff(f,x)
    for j in range(n):
        xold=N(L[j])
        xnew=? # Encode Newton's formula here
        L.append(xnew)
    return L
︡d93972f5-082e-41dd-8811-07c5e520fdfe︡{"done":true}
︠9501e13a-c978-470f-a9fb-2c94b108d473︠
newtons_list1=my_newton(?,?,?);newtons_list1
︡6800ba7b-eb17-4b61-ad32-7a990ad11fec︡{"stdout":"[-0.900000000000000, -0.532386779451968, -0.313764802062772, -0.238603685771938, -0.230633323982670, -0.230550002235008, -0.230549993213389, -0.230549993213389]\n"}︡{"done":true}
︠5e5f46af-18ed-482f-9d20-0e7ff78c44c1︠
#(d) Recall that the exact root1 is -0.23054999321338895
nlist=[j for j in range(7)]
table(columns=[nlist,simple_it_list1,newtons_list1],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)#learn the synatax of this valuable command

︡c0364a44-162b-45cd-9b6d-ded4903d89e6︡{"stdout":"+---+--------------------+---------------------+\n| n | Simple iterations  | Newton's iterations |\n+===+====================+=====================+\n| 0 | -0.900000000000000 | -0.900000000000000  |\n+---+--------------------+---------------------+\n| 1 | -0.156686068051880 | -0.532386779451968  |\n+---+--------------------+---------------------+\n| 2 | -0.224095411245832 | -0.313764802062772  |\n+---+--------------------+---------------------+\n| 3 | -0.230108474460778 | -0.238603685771938  |\n+---+--------------------+---------------------+\n| 4 | -0.230520533881549 | -0.230633323982670  |\n+---+--------------------+---------------------+\n| 5 | -0.230548030998561 | -0.230550002235008  |\n+---+--------------------+---------------------+\n| 6 | -0.230549862530082 | -0.230549993213389  |\n+---+--------------------+---------------------+\n"}︡{"done":true}
︠ce282e27-298d-43ab-9205-96372ad2f7a9︠
# Comment: ?.
︡902d9b7d-4de7-46c3-870c-64a1c2dd2157︡
︠09d14d90-6c23-427a-b53b-199d24c3afec︠
###################################
︡ffb91f94-e86c-4cfb-a7dc-79a3182e6f7b︡
︠831df516-138a-4e74-b5cc-ab556b065984︠
# Version 2: Root 2
# (a)
line_plot2=plot(x,1,2.5)
g2(x)=?
g2plot=plot(g2(x),1,2.5)
g2prime_plot=plot(?,1,2.5,color='red')
(g2plot+g2prime_plot+line_plot2).show(figsize=[4,3])
︡19abc8b8-858a-4ccd-98b2-4ec9cf9282d9︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/318/tmp_CLi3an.svg","show":true,"text":null,"uuid":"bd6b2b1e-847a-43da-882d-c84b16acb659"},"once":false}︡{"done":true}
︠903264a6-ea0c-4555-b767-9ec80ce9ee11︠
# (b) g2 works well for root2; there is an interval containing root2 where gprime is ?. Let x0=1.2
simple_it_list2=simple_iteration(?,?,?);simple_it_list2
︡552cf273-d7c3-4304-8fc6-b4dec6dfc937︡{"stdout":"[1.20000000000000, 2.16330374133256, 2.02896192145109, 2.13040446092206, 2.05760815511591, 2.11206412847833, 2.07244694614844, 2.10190300751602]\n"}︡{"done":true}
︠60522713-a252-4d7d-92bb-239d6a131bc6︠
# (c)
newtons_list2=my_newton(?,1.2,7);newtons_list2
︡cd1489f0-87e1-4b40-9150-c9761e193cb2︡{"stdout":"[1.20000000000000, 2.01815229223825, 2.08809908910110, 2.08958417522238, 2.08958484948430, 2.08958484948444, 2.08958484948444, 2.08958484948444]\n"}︡{"done":true}
︠535887d5-c9de-4c0a-a491-e28d21a391b5︠
#(d) Recal exact root2: 2.0895848494844653
table(columns=[nlist,?,?],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)

###############
#Grading: There are 20 red question marks; correct replacement for each is 0.5 point. There are two brown question marks (theoretical); each replacement 2 points. Total: 12 points.









